# -----------------------------
# PostgreSQL configuration file
# -----------------------------
#
# This file consists of lines of the form:
#
#   name = value
#
# (The "=" is optional.)  Whitespace may be used.  Comments are introduced with
# "#" anywhere on a line.  The complete list of parameter names and allowed
# values can be found in the PostgreSQL documentation.
#
# The commented-out settings shown in this file represent the default values.
# Re-commenting a setting is NOT sufficient to revert it to the default value;
# you need to reload the server.
#
# This file is read on server startup and when the server receives a SIGHUP
# signal.  If you edit the file on a running system, you have to SIGHUP the
# server for the changes to take effect, run "pg_ctl reload", or execute
# "SELECT pg_reload_conf()".  Some parameters, which are marked below,
# require a server shutdown and restart to take effect.
#
# Any parameter can also be given as a command-line option to the server, e.g.,
# "postgres -c log_connections=on".  Some parameters can be changed at run time
# with the "SET" SQL command.
#
# Memory units:  kB = kilobytes        Time units:  ms  = milliseconds
#                MB = megabytes                     s   = seconds
#                GB = gigabytes                     min = minutes
#                TB = terabytes                     h   = hours
#                                                   d   = days


#------------------------------------------------------------------------------
# FILE LOCATIONS
#------------------------------------------------------------------------------

# The default values of these variables are driven from the -D command-line
# option or PGDATA environment variable, represented here as ConfigDir.

#data_directory = 'ConfigDir'		# use data in another directory
					# (change requires restart)
#hba_file = 'ConfigDir/pg_hba.conf'	# host-based authentication file
					# (change requires restart)
#ident_file = 'ConfigDir/pg_ident.conf'	# ident configuration file
					# (change requires restart)

# If external_pid_file is not explicitly set, no extra PID file is written.
#external_pid_file = ''			# write an extra PID file
					# (change requires restart)


#------------------------------------------------------------------------------
# CONNECTIONS AND AUTHENTICATION
#------------------------------------------------------------------------------

# - Connection Settings -

listen_addresses = '*'		# what IP address(es) to listen on;
					# comma-separated list of addresses;
					# defaults to 'localhost'; use '*' for all
					# (change requires restart)
port = port_placeholder				# (change requires restart)
max_connections = 1000			# (change requires restart)
#superuser_reserved_connections = 3	# (change requires restart)
unix_socket_directories = 'unix_socket_dir_place_holder'	# comma-separated list of directories
					# (change requires restart)
#unix_socket_group = ''			# (change requires restart)
#unix_socket_permissions = 0777		# begin with 0 to use octal notation
					# (change requires restart)
#bonjour = off				# advertise server via Bonjour
					# (change requires restart)
#bonjour_name = ''			# defaults to the computer name
					# (change requires restart)

# - TCP Keepalives -
# see "man 7 tcp" for details

#tcp_keepalives_idle = 0		# TCP_KEEPIDLE, in seconds;
					# 0 selects the system default
#tcp_keepalives_interval = 0		# TCP_KEEPINTVL, in seconds;
					# 0 selects the system default
#tcp_keepalives_count = 0		# TCP_KEEPCNT;
					# 0 selects the system default
# - Authentication -

#authentication_timeout = 1min		# 1s-600s
#password_encryption = md5		# md5 or scram-sha-256
#db_user_namespace = off

# GSSAPI using Kerberos
#krb_server_keyfile = ''
#krb_caseins_users = off

# - SSL -

#ssl = off
#ssl_ca_file = ''
#ssl_cert_file = 'server.crt'
#ssl_crl_file = ''
#ssl_key_file = 'server.key'
#ssl_ciphers = 'HIGH:MEDIUM:+3DES:!aNULL' # allowed SSL ciphers
#ssl_prefer_server_ciphers = on
#ssl_ecdh_curve = 'prime256v1'
#ssl_dh_params_file = ''
#ssl_passphrase_command = ''
#ssl_passphrase_command_supports_reload = off

comp_node_id = comp_node_id_placeholder
#------------------------------------------------------------------------------
# RESOURCE USAGE (except WAL)
#------------------------------------------------------------------------------

# - Memory -

shared_buffers = 1024MB #512MB			# min 128kB
					# (change requires restart)
#huge_pages = try			# on, off, or try
					# (change requires restart)
temp_buffers = 32MB			# min 800kB
#max_prepared_transactions = 0		# zero disables the feature
					# (change requires restart)
# Caution: it is not advisable to set max_prepared_transactions nonzero unless
# you actively intend to use prepared transactions.
work_mem = 8MB				# min 64kB
#maintenance_work_mem = 64MB		# min 1MB
#autovacuum_work_mem = -1		# min 1MB, or -1 to use maintenance_work_mem
#max_stack_depth = 2MB			# min 100kB
dynamic_shared_memory_type = posix	# the default is the first option
					# supported by the operating system:
					#   posix
					#   sysv
					#   windows
					#   mmap
					# use none to disable dynamic shared memory
					# (change requires restart)

# - Disk -

#temp_file_limit = -1			# limits per-process temp file space
					# in kB, or -1 for no limit

# - Kernel Resources -

#max_files_per_process = 1000		# min 25
					# (change requires restart)

# - Cost-Based Vacuum Delay -

#vacuum_cost_delay = 0			# 0-100 milliseconds
#vacuum_cost_page_hit = 1		# 0-10000 credits
#vacuum_cost_page_miss = 10		# 0-10000 credits
#vacuum_cost_page_dirty = 20		# 0-10000 credits
#vacuum_cost_limit = 200		# 1-10000 credits

# - Background Writer -

#bgwriter_delay = 200ms			# 10-10000ms between rounds
#bgwriter_lru_maxpages = 100		# max buffers written/round, 0 disables
#bgwriter_lru_multiplier = 2.0		# 0-10.0 multiplier on buffers scanned/round
#bgwriter_flush_after = 512kB		# measured in pages, 0 disables

# - Asynchronous Behavior -

#effective_io_concurrency = 1		# 1-1000; 0 disables prefetching
max_worker_processes = 320		# (change requires restart) must be >= the number of PostgreSQL databases in the cluster.
#max_parallel_maintenance_workers = 2	# taken from max_parallel_workers
max_parallel_workers_per_gather = 64	# taken from max_parallel_workers
#parallel_leader_participation = on
max_parallel_workers = 256		# maximum number of max_worker_processes that
					# can be used in parallel operations
#old_snapshot_threshold = -1		# 1min-60d; -1 disables; 0 is immediate
					# (change requires restart)
#backend_flush_after = 0		# measured in pages, 0 disables


#------------------------------------------------------------------------------
# WRITE-AHEAD LOG
#------------------------------------------------------------------------------

# - Settings -

wal_level = minimal			# minimal, replica, or logical
					# (change requires restart)
fsync = on				# flush data to disk for crash safety
					# (turning this off can cause
					# unrecoverable data corruption)
#synchronous_commit = on		# synchronization level;
					# off, local, remote_write, remote_apply, or on
#wal_sync_method = fsync		# the default is the first option
					# supported by the operating system:
					#   open_datasync
					#   fdatasync (default on Linux)
					#   fsync
					#   fsync_writethrough
					#   open_sync
#full_page_writes = on			# recover from partial page writes
wal_compression = on			# enable compression of full-page writes
#wal_log_hints = off			# also do full page writes of non-critical updates
					# (change requires restart)
#wal_buffers = -1			# min 32kB, -1 sets based on shared_buffers
					# (change requires restart)
#wal_writer_delay = 200ms		# 1-10000 milliseconds
wal_writer_flush_after = 0		# measured in pages, 0 disables. make sure WAL is always fsync'ed after writes.

#commit_delay = 0			# range 0-100000, in microseconds
#commit_siblings = 5			# range 1-1000

# - Checkpoints -

#checkpoint_timeout = 5min		# range 30s-1d
max_wal_size = 256MB
min_wal_size = 1GB
#checkpoint_completion_target = 0.5	# checkpoint target duration, 0.0 - 1.0
#checkpoint_flush_after = 256kB		# measured in pages, 0 disables
#checkpoint_warning = 30s		# 0 disables

# - Archiving -

#archive_mode = off		# enables archiving; off, on, or always
				# (change requires restart)
#archive_command = ''		# command to use to archive a logfile segment
				# placeholders: %p = path of file to archive
				#               %f = file name only
				# e.g. 'test ! -f /mnt/server/archivedir/%f && cp %p /mnt/server/archivedir/%f'
#archive_timeout = 0		# force a logfile segment switch after this
				# number of seconds; 0 disables


#------------------------------------------------------------------------------
# REPLICATION
#------------------------------------------------------------------------------

# - Sending Servers -

# Set these on the master and on any standby that will send replication data.

max_wal_senders = 0		# max number of walsender processes
				# (change requires restart)
#wal_keep_segments = 0		# in logfile segments; 0 disables
#wal_sender_timeout = 60s	# in milliseconds; 0 disables

#max_replication_slots = 10	# max number of replication slots
				# (change requires restart)
#track_commit_timestamp = off	# collect timestamp of transaction commit
				# (change requires restart)

# - Master Server -

# These settings are ignored on a standby server.

#synchronous_standby_names = ''	# standby servers that provide sync rep
				# method to choose sync standbys, number of sync standbys,
				# and comma-separated list of application_name
				# from standby(s); '*' = all
#vacuum_defer_cleanup_age = 0	# number of xacts by which cleanup is delayed

# - Standby Servers -

# These settings are ignored on a master server.

#hot_standby = on			# "off" disallows queries during recovery
					# (change requires restart)
#max_standby_archive_delay = 30s	# max delay before canceling queries
					# when reading WAL from archive;
					# -1 allows indefinite delay
#max_standby_streaming_delay = 30s	# max delay before canceling queries
					# when reading streaming WAL;
					# -1 allows indefinite delay
#wal_receiver_status_interval = 10s	# send replies at least this often
					# 0 disables
#hot_standby_feedback = off		# send info from standby to prevent
					# query conflicts
#wal_receiver_timeout = 60s		# time that receiver waits for
					# communication from master
					# in milliseconds; 0 disables
#wal_retrieve_retry_interval = 5s	# time to wait before retrying to
					# retrieve WAL after a failed attempt

# - Subscribers -

# These settings are ignored on a publisher.

max_logical_replication_workers = 0	# taken from max_worker_processes
					# (change requires restart)
#max_sync_workers_per_subscription = 2	# taken from max_logical_replication_workers


#------------------------------------------------------------------------------
# QUERY TUNING
#------------------------------------------------------------------------------

# - Planner Method Configuration -

#enable_bitmapscan = on
#enable_hashagg = on
#enable_hashjoin = on
#enable_indexscan = on
#enable_indexonlyscan = on
#enable_material = on
#enable_mergejoin = on
#enable_nestloop = on
enable_parallel_append = on
#enable_seqscan = on
#enable_sort = on
#enable_tidscan = on
enable_partitionwise_join = on
enable_partitionwise_aggregate = on
enable_parallel_hash = on
enable_partition_pruning = on
enable_parallel_remotescan = on
# - Planner Cost Constants -

#seq_page_cost = 1.0			# measured on an arbitrary scale
#random_page_cost = 2.0			# same scale as above
#cpu_tuple_cost = 0.01			# same scale as above
#cpu_index_tuple_cost = 0.005		# same scale as above
#cpu_operator_cost = 0.0025		# same scale as above
#parallel_tuple_cost = 0.1		# same scale as above
#parallel_setup_cost = 1000.0	# same scale as above
parallel_setup_cost = 300.0

#jit_above_cost = 100000		# perform JIT compilation if available
					# and query more expensive than this;
					# -1 disables
#jit_inline_above_cost = 500000		# inline small functions if query is
					# more expensive than this; -1 disables
#jit_optimize_above_cost = 500000	# use expensive JIT optimizations if
					# query is more expensive than this;
					# -1 disables

#min_parallel_table_scan_size = 8MB
#min_parallel_index_scan_size = 512kB
#effective_cache_size = 4GB

# - Genetic Query Optimizer -

#geqo = on
#geqo_threshold = 12
#geqo_effort = 5			# range 1-10
#geqo_pool_size = 0			# selects default based on effort
#geqo_generations = 0			# selects default based on effort
#geqo_selection_bias = 2.0		# range 1.5-2.0
#geqo_seed = 0.0			# range 0.0-1.0

# - Other Planner Options -

#default_statistics_target = 100	# range 1-10000
#constraint_exclusion = partition	# on, off, or partition
#cursor_tuple_fraction = 0.1		# range 0.0-1.0
#from_collapse_limit = 8
#join_collapse_limit = 8		# 1 disables collapsing of explicit
					# JOIN clauses
#force_parallel_mode = off
#jit = off				# allow JIT compilation


#------------------------------------------------------------------------------
# REPORTING AND LOGGING
#------------------------------------------------------------------------------

# - Where to Log -

#log_destination = 'stderr'		# Valid values are combinations of
					# stderr, csvlog, syslog, and eventlog,
					# depending on platform.  csvlog
					# requires logging_collector to be on.

# This is used when logging to stderr:
logging_collector = on		# Enable capturing of stderr and csvlog
					# into log files. Required to be on for
					# csvlogs.
					# (change requires restart)

# These are only used if logging_collector is on:
#log_directory = 'log'			# directory where log files are written,
					# can be absolute or relative to PGDATA
log_filename = 'kunlun-postgresql-%Y-%m-%d.log'	# log file name pattern,
					# can include strftime() escapes
#log_file_mode = 0600			# creation mode for log files,
					# begin with 0 to use octal notation
#log_truncate_on_rotation = off		# If on, an existing log file with the
					# same name as the new log file will be
					# truncated rather than appended to.
					# But such truncation only occurs on
					# time-driven rotation, not on restarts
					# or size-driven rotation.  Default is
					# off, meaning append to existing files
					# in all cases.
log_rotation_age = 0			# Automatic rotation of logfiles will
					# happen after that time.  0 disables.
log_rotation_size = 100MB		# Automatic rotation of logfiles will
					# happen after that much log output.
					# 0 disables.

# These are relevant when logging to syslog:
#syslog_facility = 'LOCAL0'
#syslog_ident = 'postgres'
#syslog_sequence_numbers = on
#syslog_split_messages = on

# This is only relevant when logging to eventlog (win32):
# (change requires restart)
#event_source = 'PostgreSQL'

# - When to Log -

#log_min_messages = warning		# values in order of decreasing detail:
					#   debug5
					#   debug4
					#   debug3
					#   debug2
					#   debug1
					#   info
					#   notice
					#   warning
					#   error
					#   log
					#   fatal
					#   panic

#log_min_error_statement = error	# values in order of decreasing detail:
					#   debug5
					#   debug4
					#   debug3
					#   debug2
					#   debug1
					#   info
					#   notice
					#   warning
					#   error
					#   log
					#   fatal
					#   panic (effectively off)

log_min_duration_statement = 10000	# -1 is disabled, 0 logs all statements
					# and their durations, > 0 logs only
					# statements running at least this number
					# of milliseconds


# - What to Log -

#debug_print_parse = off
#debug_print_rewritten = off
#debug_print_plan = off
#debug_pretty_print = on
log_checkpoints = on
log_connections = on
log_disconnections = on
#log_duration = off
log_error_verbosity = default 		# terse, default, or verbose messages
#log_hostname = off
log_line_prefix = '%m [%p] %q %u@%d/%a: [%e]'
#log_line_prefix = '%m [%p] '		# special values:
					#   %a = application name
					#   %u = user name
					#   %d = database name
					#   %r = remote host and port
					#   %h = remote host
					#   %p = process ID
					#   %t = timestamp without milliseconds
					#   %m = timestamp with milliseconds
					#   %n = timestamp with milliseconds (as a Unix epoch)
					#   %i = command tag
					#   %e = SQL state
					#   %c = session ID
					#   %l = session line number
					#   %s = session start timestamp
					#   %v = virtual transaction ID
					#   %x = transaction ID (0 if none)
					#   %q = stop here in non-session
					#        processes
					#   %% = '%'
					# e.g. '<%u%%%d> '
log_lock_waits = on			# log lock waits >= deadlock_timeout
log_statement = 'ddl'			# none, ddl, mod, all
#log_replication_commands = off
log_temp_files = 1024			# log temporary files equal or larger
					# than the specified size in kilobytes;
					# -1 disables, 0 logs all temp files
log_timezone = 'Asia/Shanghai'

#------------------------------------------------------------------------------
# PROCESS TITLE
#------------------------------------------------------------------------------
cluster_name = 'kunlun'                        # added to process titles if nonempty
                                       # (change requires restart)

#update_process_title = on


#------------------------------------------------------------------------------
# STATISTICS
#------------------------------------------------------------------------------

# - Query and Index Statistics Collector -

#track_activities = on
#track_counts = on
#track_io_timing = off
#track_functions = none			# none, pl, all
#track_activity_query_size = 1024	# (change requires restart)
#stats_temp_directory = 'pg_stat_tmp'


# - Monitoring -

#log_parser_stats = off
#log_planner_stats = off
#log_executor_stats = off
#log_statement_stats = off


#------------------------------------------------------------------------------
# AUTOVACUUM
#------------------------------------------------------------------------------

#autovacuum = on			# Enable autovacuum subprocess?  'on'
					# requires track_counts to also be on.
#log_autovacuum_min_duration = -1	# -1 disables, 0 logs all actions and
					# their durations, > 0 logs only
					# actions running at least this number
					# of milliseconds.
#autovacuum_max_workers = 3		# max number of autovacuum subprocesses
					# (change requires restart)
#autovacuum_naptime = 1min		# time between autovacuum runs
#autovacuum_vacuum_threshold = 10000	# min number of row updates before
					# vacuum
#autovacuum_analyze_threshold = 10000	# min number of row updates before
					# analyze
#autovacuum_vacuum_scale_factor = 0.2	# fraction of table size before vacuum
#autovacuum_analyze_scale_factor = 0.1	# fraction of table size before analyze
#autovacuum_freeze_max_age = 200000000	# maximum XID age before forced vacuum
					# (change requires restart)
#autovacuum_multixact_freeze_max_age = 400000000	# maximum multixact age
					# before forced vacuum
					# (change requires restart)
#autovacuum_vacuum_cost_delay = 20ms	# default vacuum cost delay for
					# autovacuum, in milliseconds;
					# -1 means use vacuum_cost_delay
#autovacuum_vacuum_cost_limit = -1	# default vacuum cost limit for
					# autovacuum, -1 means use
					# vacuum_cost_limit


#------------------------------------------------------------------------------
# CLIENT CONNECTION DEFAULTS
#------------------------------------------------------------------------------

# - Statement Behavior -

#client_min_messages = notice		# values in order of decreasing detail:
					#   debug5
					#   debug4
					#   debug3
					#   debug2
					#   debug1
					#   log
					#   notice
					#   warning
					#   error
#search_path = '"$user", public'	# schema names
#row_security = on
#default_tablespace = ''		# a tablespace name, '' uses the default
#temp_tablespaces = ''			# a list of tablespace names, '' uses
					# only default tablespace
#check_function_bodies = on
#default_transaction_isolation = 'read committed'
#default_transaction_read_only = off
#default_transaction_deferrable = off
#session_replication_role = 'origin'
statement_timeout = 100000			# in milliseconds
lock_timeout = 100000			# in milliseconds
idle_in_transaction_session_timeout = 300000	# in milliseconds
#vacuum_freeze_min_age = 50000000
#vacuum_freeze_table_age = 150000000
#vacuum_multixact_freeze_min_age = 5000000
#vacuum_multixact_freeze_table_age = 150000000
#vacuum_cleanup_index_scale_factor = 0.1	# fraction of total number of tuples
						# before index cleanup, 0 always performs
						# index cleanup
#bytea_output = 'hex'			# hex, escape
#xmlbinary = 'base64'
#xmloption = 'content'
#gin_fuzzy_search_limit = 0
#gin_pending_list_limit = 4MB

# - Locale and Formatting -

datestyle = 'iso, ymd'
#intervalstyle = 'postgres'
intervalstyle=iso_8601
timezone = 'Asia/Shanghai'
#timezone_abbreviations = 'Default'     # Select the set of available time zone
					# abbreviations.  Currently, there are
					#   Default
					#   Australia (historical usage)
					#   India
					# You can create your own file in
					# share/timezonesets/.
#extra_float_digits = 0			# min -15, max 3
#client_encoding = sql_ascii		# actually, defaults to database
					# encoding

# These settings are initialized by initdb, but they can be changed.
lc_messages = 'en_US.UTF-8'			# locale for system error message
					# strings
lc_monetary = 'en_US.UTF-8'			# locale for monetary formatting
lc_numeric = 'en_US.UTF-8'			# locale for number formatting
lc_time = 'en_US.UTF-8'				# locale for time formatting

# default configuration for text search
default_text_search_config = 'pg_catalog.english'

# - Shared Library Preloading -

shared_preload_libraries = 'global_deadlock_detector.so,remote_rel.so,ddl2kunlun.so,libtornado_cn.so'	# (change requires restart)
#local_preload_libraries = ''
#session_preload_libraries = ''
#jit_provider = 'llvmjit'		# JIT library to use

# - Other Defaults -

#dynamic_library_path = '$libdir'


#------------------------------------------------------------------------------
# LOCK MANAGEMENT
#------------------------------------------------------------------------------

deadlock_timeout = 10s
max_locks_per_transaction = 10000		# min 10
					# (change requires restart)
#max_pred_locks_per_transaction = 256	# min 10
					# (change requires restart)
#max_pred_locks_per_relation = -2	# negative values mean
					# (max_pred_locks_per_transaction
					#  / -max_pred_locks_per_relation) - 1
#max_pred_locks_per_page = 2            # min 0


#------------------------------------------------------------------------------
# VERSION AND PLATFORM COMPATIBILITY
#------------------------------------------------------------------------------

# - Previous PostgreSQL Versions -

#array_nulls = on
#backslash_quote = safe_encoding	# on, off, or safe_encoding
#default_with_oids = off
#escape_string_warning = on
#lo_compat_privileges = off
#operator_precedence_warning = off
#quote_all_identifiers = off
#standard_conforming_strings = on
#synchronize_seqscans = on

# - Other Platforms and Clients -

#transform_null_equals = off


#------------------------------------------------------------------------------
# ERROR HANDLING
#------------------------------------------------------------------------------

#exit_on_error = off			# terminate session on any error?
#restart_after_crash = on		# reinitialize after backend crash?
#data_sync_retry = off			# retry or panic on failure to fsync
					# data?
					# (change requires restart)


#------------------------------------------------------------------------------
# CONFIG FILE INCLUDES
#------------------------------------------------------------------------------

# These options allow settings to be loaded from files other than the
# default postgresql.conf.

#include_dir = ''			# include files ending in '.conf' from
					# a directory, e.g., 'conf.d'
#include_if_exists = ''			# include file only if it exists
#include = ''				# include file


#------------------------------------------------------------------------------
# CUSTOMIZED OPTIONS
#------------------------------------------------------------------------------

# NO. of seconds to wait before next attempt to fetch DDL logs from meta-data cluster after an attempt with no DDL logs.

# NO. of seconds to wait before next round of deadlock detction.
# global deadlock detector works with kunlun-mysql.
global_deadlock_detector.naptime = 3

# Victim policy for global deadlock resolving.
global_deadlock_detector_victim_policy = KILL_MOST_ROWS_LOCKED

# GTSS commit log group send parameters.
cluster_commitlog_group_size = 8

#---------
# mysql connection parameters to storage shards as well as server side mysql protocol.
#---------
mysql_connect_timeout = 50
mysql_read_timeout = 50
mysql_write_timeout = 50
mysql_max_packet_size = 1073741824
# NO. of times to retry connecting/writing/reading to/from peer
mysql_net_retry_count = 10
# MySQL server protocol per-client connection read/write buffer size in bytes.
mysql_net_buffer_length=65536

# whether produce coredump file when any postgres process catches fatal
# signals SIGSEGV, SIGABORT, SIGBUS, SIGILL, and SIGFPE.
# coredump files are very useful for bug diagnosis, but it takes a few seconds
# to produce a coredump file.
# Users should set /proc/sys/kernel/core_pattern as something like
# /data/core.%e.%p.%h.%t :
# echo /data/core.%e.%p.%h.%t > /proc/sys/kernel/core_pattern
enable_coredump = true

# Whether write core stack trace into log file when any postgres process
# catches fatal signals SIGSEGV, SIGABORT, SIGBUS, SIGILL, and SIGFPE.
enable_stacktrace = true

## Enable compression in mysql connection to storage shards, do NOT turn on, not tested.
#mysql_transmit_compress = 0

# Do NOT turn on unless you want to manually apply DDL logs.
# Only to be used internally.
#replaying_ddl_log = 0

# Unconditionally turn off global deadlock detection although the 'GDD' process
# is running. Turn this off when using a storage node other than kunlun-storage.
enable_global_deadlock_detection = true

# Notify global deadlock detector(gdd) to start a round of deadlock detection
# if an insert/delete/update statement doesn't
# get result from storage shards after wating this much milli-seconds.
# set this smaller than statement_timeout otherwise gdd can't be very helpful.
start_global_deadlock_detection_wait_timeout=500

# Max wait time in seconds of a commit log request to meta-data shard
# primary node.
global_txn_commit_log_wait_max_secs = 10

# Max NO. of blocks ever allowed to be allocated to one session to insert rows, i.e. max insert buffer size.
# if more rows to insert, will send existing to storage node to spare the insert buffer.
max_remote_insert_blocks=1024

# Try to push down table joins if both left and right tables are in the same storage shard.
# Pushing down such joins will generally produce better performance.
enable_remote_join_pushdown = true

# Try to push down semi/anti joins if both left and right tables are in the same storage shard.
# Pushing down such joins will generally produce better performance.
enable_remote_subquery_pushdown = true

# Try to push down aggregates to storage shard for better performance.
# Pushing down aggregates can often produce much better performance and
# significantly minimize tuple transfer from storage shards to computing nodes.
enable_remote_agg_pushdown = true

# Try to push down sorts to storage shard for better performance.
# Pushing down sorts to storage shard can often produce much performance
# because multiple storage nodes can do sort in parallel.
enable_remote_orderby_pushdown = true

# Try to push down deduplication to storage shard for better performance.
# Pushing down deduplication to storage shard can often produce better
# performance because multiple storage nodes can do deduplication in parallel
# and reduces the amount of tuples transfered from storage shards to computing nodes.
enable_remote_distinct_pushdown = true

# Try to push down LIMIT clause to storage shard for better performance.
# Pushing down LIMIT to storage shard can often produce better performance
# because multiple storage nodes can reduce the amount of tuples transfered
# from storage shards to computing nodes.
enable_remote_limit_pushdown = true

# check current primary nodes of all stoarge shards and the metadata shard,
# if no such actions performed since last such actions for this many seconds.
check_primary_interval_secs = 3

# True if putting nulls at first when performing ascending sorting
default_nulls_smallest = true

# the TCP port the server listens on for mysql clients using MySQL protocols.
mysql_port= mysql_port_placeholder

# MySQL protocol compression algorithms to use, can only be a combination
# of 'zlib', 'zstd', and 'uncompressed'
mysql_protocol_compression_algos='zlib, zstd, uncompressed'

# Add settings for extensions here

# String key-part length suffix used in DDL statements sent to storage shard
# when a text column is used as index key.
remote_rel.str_key_part_len = 64

# Whether send result set metadata for connections with MySQL protocol
# Including column name and data type, table and database name, etc
mysql_send_resultset_metadata = true


# How many rows to fetch via MySQL binary protocol in an EXECUTE or FETCH command,
# 0 if fetch all at once in EXECUTE.
mysql_protocol_ps_exec_fetch_rows = 0

# A transaction newly started in a session with autocommit off is marked
# explicit so it is not committed until a COMMIT statement is executed.
#
# When autocommit is true(by default so), kunlun-server works like PostgreSQL
# for transaction handling --- if a statement is not executed in an explicit
# transaction, it is by itself an (autocommit) transaction.
autocommit= true


# A few mapping are deduced from docs and public info, whether use
# such deduced mapping.
enable_pg_mysql_charset_mapping_deduction = true
		
# Default PostgreSQL collation for MySQL sessions if no valid PostgreSQL collation
# in pg_mysql_collation_mapping given MySQL charset and collation.
default_pgsql_collation = ucs_basic

# The MySQL version that KunlunServer declares itself as to the MySQL
# client connectors.
# If necessary one can change this to an old or new version of MySQL
# in order for some MySQL connector to avoid sending certain SQL statements
# that KunlunServer doesn't support during connection phase.
# Set this with care because invalid version string format will cause mysql
# connectors unable to connect to KunlunServer instances.
declared_mysql_server_version = '8.0.29'

# Wrap user query into an internal subtransaction and roll back the subtransaction
# in the event of an error, rather than rolling back the entire transaction.
# Turning on this feature will make transaction processing more similar to MySQL.
enable_stmt_subxact = false

# Use the MySQL binary protocol to communicate with storage shards, reducing
# the SQL parsing overhead of storage allocation and the compute node overhead
# of transforming the results.
# By default, compute nodes use the binary protocol only if client uses the 
# prepare/execute protocol.
enable_shard_binary_protocol = true

# If use MySQL binary protocol to communicate with storage shards, when the amount
# of data is large, use cursor to fetch data in batches to avoid the materialization overhead
# caused by contention for connections.
enable_remote_cursor = false

# Prefetch rows for cursors that are used to get data from remote storage shards in batches.
remote_cursor_prefetch_rows = 1000

# Only used in mysql connections
# Whether to transform all CREATE DATABASE stmts to CREATE SCHEMA stmts. See ticket #1110 for more.
transform_create_db_to_schema = true

# enable global mvcc to get a consistent snapshot in the whole cluster
enable_global_mvcc = false

# Default schema for MySQL connections at connection establishment,
# Also, if in USE stmt, mysql_select_db() or CHANGE_USER command, a schema name is specified
# as 'db.schema' but not found in current db, also use this default schema as search_path.
#
# In all above cases if it's empty or invalid(not found), do the same as
# PostgreSQL connections and set search_path to '$user, public' schema.
mysql_default_schema = ''

# Default database for MySQL connections only at connection establishment.
# It's used as the db to connect to when specified db name (not of abc.def format but simply abc)
# isn't valid. And in this case it will be assumed as schema name under this db instead.
mysql_default_db = 'postgres'

# The maximum number of retries when the storage node report ER_NO_SUCH_TABLE due to table migration.
# Note: each retry will wait for 1s.
table_migration_recovery_max_retries = 8

# A cluster deployment mode when the cluster has only one shard. 
# In this mode, CN only changes the local metadata when executing DDL, and allows users to freely
# define the correspondence between the CN schema and the CN schema.
single_shard_mode= false

# Specify the collation used by string operators/functions in pushdown sql
enable_collation_pushdown = true

trace_global_deadlock_detection = true

# The default optimizer_switch value used by query optimizer in the storage node
default_storage_optimizer_switch = 'materialization=off'

# Reject connection requests if there are remaining DDL logs to replay.
# Turning this on could slow down speed of connection establishment,
# and Klustron has robustly guarantee metadata consistency among all cluster nodes.
reject_conn_ddl_lag = false

# Is current computing node(CN) read only?
# A read only computing node forbids DDL and insert/delete/update statements.
CN_read_only = false

# The charset and collation name set to storage node connections of each client session.
# Must set a valid charset name otherwise CN can't connect to storage nodes.
storage_set_names_charset = 'utf8mb4'
storage_set_names_collate = 'utf8mb4_0900_bin'

# The charset and collation name used to create tables in storage nodes.
# Must set a valid charset name otherwise CREATE TABLE fails
storage_table_collate = 'utf8mb4_0900_bin'
storage_table_charset = 'utf8mb4'

# In a MySQL session, if a DDL stmt parses in computing node parser, transform it with DDL2KUNLUN and parse again.
# This is seldom necessary. Only do so if CN can't execute the DDL stmt correctly, as a backup approach."),
reparse_ddl_with_ddl2kunlun = false

# Only set to 'READ COMMITTED' before starting a transaction which updates/deletes
# multiple rows, and immediately set it back to 'REPEATABLE READ' afterwards.
default_backend_trx_isolation = 'repeatable read'
